HDU 5088 Revenge of Nim II (高斯消元??)

Revenge of Nim II

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 589    Accepted Submission(s): 208


Problem Description
Nim is a mathematical game of strategy in which two players take turns removing objects from distinct heaps. On each turn, a player must remove at least one object, and may remove any number of objects provided they all come from the same heap.
---Wikipedia

Today, Nim takes revenge on you, again. As you know, the rule of Nim game is rather unfair, only the nim-sum (⊕) of the sizes of the heaps is zero will the first player lose. To ensure the fairness of the game, the second player has a chance to move some (can be zero) heaps before the game starts, but he has to move one heap entirely, i.e. not partially. Of course, he can’t move all heaps out, at least one heap should be left for playing. Will the second player have the chance to win this time?
 

Input
The first line contains a single integer T, indicating the number of test cases. 

Each test case begins with an integer N, indicating the number of heaps. Then N integer Ai follows, indicating the number of each heap.

[Technical Specification]
1. 1 <= T <= 100
2. 1 <= N <= 1 000
3. 1 <= Ai <= 1 000 000 000 000
 

Output
For each test case, output “Yes” if the second player can win by moving some (can be zero) heaps out, otherwise “No”.
 

Sample Input
  
  
3 1 2 3 2 2 2 5 1 2 3 4 5
 

Sample Output
  
  
No Yes Yes
Hint
For the third test case, the second player can move heaps with 4 and 5 objects out, so the nim-sum of the sizes of the left heaps is 1⊕2⊕3 = 0.
 

Source
 

题目大意:给定n堆石子,可以取走若干堆,使得剩下的石子按照尼姆博奕的游戏规则可以使先手必败,问是否有这样的方案。


解题思路:对于尼姆博奕的游戏,如果有m堆石子,每堆石子的数目分别为a1,a2,……,am,如果a1^a2^……^am = 0,那么先手必败。
因此,实际上就是在n个数中选一个有m个数的非空集合,使得这个集合的所有元素值异或后结果为0。
对于一个数x,可以看做是由0和1组成的二进制,而这个二进制数可以看做是一个k维向量。m个数就组成了m个k维的向量(如果某个数不足k位,前面补0)。
同时也组成了一个m*k的01矩阵,能异或出0的充分条件是对这个01矩阵高斯消元以后矩阵的秩小于矩阵的min(行数,列数)(也即存在一行全零,全零行就是异或出来的一行)
(矩阵的秩一定小于等于矩阵行列的最小值,因为n堆石子中每堆石子的数目最大值是10^12<2^40,矩阵的列数小于40,行数范围是1~1000,当n>40时,矩阵的,秩小于40,则矩阵一定高斯消元以后一定存在一行全为0的。)


代码如下:

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <numeric>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <fstream>
#include <limits.h>
#define debug "output for debug\n"
#define pi (acos(-1.0))
#define eps (1e-6)
#define inf (1<<28)
#define sqr(x) (x) * (x)
#define mod 1000000007
using namespace std;
typedef long long ll;
typedef unsigned long long ULL;
ll a[1005];
int gauss(int n,int var)
{
    int r,c,tmpr;
    for(r=0,c=0;r<n&&c<var;r++,c++)
    {
        for(tmpr=r;tmpr<n;tmpr++)
        {
            if(a[tmpr]&(1ll<<c))
                break;
        }
        if(tmpr==n)
        {
            r--;
            continue;
        }
        swap(a[tmpr],a[r]);
        for(int i=r+1;i<n;i++)
        {
            if(a[i]&(1ll<<c))
                a[i]^=a[r];
        }
    }
    return r;
}


int main()
{
    int i,j,k,n,t;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d",&n);
        for(i=0;i<n;i++)
            scanf("%I64d",&a[i]);
        if(n>40)
        {
            printf("Yes\n");
            continue;
        }
        if(gauss(n,40)<n)
            printf("Yes\n");
        else
            printf("No\n");
    }
    return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值